<template>
	<div
		class="mx-auto w-full lg:w-960 bg-white md:rounded-lg lg:rounded px-4 pt-5 md:px-6 md:pt-6 md:pb-8 lg:p-14 md:mb-4"
	>
		<MkPageSpinner v-if="ORDER_LOADED" />
		<div v-else>
			<div class="w-full flex flex-col md:flex-row">
				<div class="w-full justify-between">
					<div class="flex flex-col mb-8 md:mb-0">
						<div class="flex flex-row justify-between items-center">
							<h2
								class="font-secondary-font-regular text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10 pr-4"
							>
								Order # [{{ orderNumber }}#]
							</h2>
							<span
								ref="print_btn"
								class="cursor-pointer focus:outline-none focus:ring-2 focus:ring-black"
								tabindex="0"
								title="Print"
								role="button"
								@keydown.enter="print"
								@click="print"
							>
								<img src="~/assets/images/icon-print.svg" class="w-5 md:w-auto cursor-pointer" alt="" />
							</span>
						</div>
						<div class="flex flex-row">
							<span class="screen-reader-only" :aria-label="`Order Date ` + getFormattedDate(orderDate)"></span>
							<p
								aria-hidden="true"
								class="flex pt-4 lg:pt-8 font-primary-font-light md:text-lg lg:text-xl md:leading-6 lg:leading-6"
							>
								[{{ orderDate | ustToDate }}]
							</p>
						</div>
					</div>
				</div>
				<div class="flex flex-row md:pl-4 lg:pl-8 md:justify-between">
					<a
						v-if="
							ORDER.shippingInfo &&
							ORDER.shippingInfo.deliveries[0] &&
							ORDER.shippingInfo.deliveries[0].parcels[0] &&
							ORDER.shippingInfo.deliveries[0].parcels[0].trackingData &&
							ORDER.shippingInfo.deliveries[0].parcels[0].trackingData.trackingId &&
							!isEurope
						"
						:href="`http://www.fedex.com/Tracking?tracknumbers=${ORDER.shippingInfo.deliveries[0].parcels[0].trackingData.trackingId}`"
						class="bg-white font-primary-font-regular text-black border-grey-40 border p-2 rounded-3xl hover:bg-grey-10 hover:border-grey-20 flex justify-center active:outline-none focus:outline-none focus:ring-1 focus:ring-black min-w-150 h-8 items-center text-sm leading-4 pt-2 pb-1.5 mr-6 md:mr-4 lg:mr-8"
						target="_blank"
					>
						Tracking Info
					</a>
					<div class="justify-end">
						<MkSecondaryButton
							:loading="loading"
							class="items-center h-8"
							:button-title="'Reorder'"
							mksecondary-class="min-w-150 py-2 leading-4 text-sm"
							order-detail
							@click="reorder"
						/>
					</div>
				</div>
			</div>
			<div role="table">
				<div role="row" class="hidden md:flex pb-6 md:mt-8 lg:mt-12">
					<div class="w-470">
						<div role="columnheader" class="md:text-sm lg:text-base font-primary-font-bold"> Item </div>
					</div>
					<div class="w-cart-card-md grid grid-cols-3 font-primary-font-bold md:text-sm lg:text-base">
						<div role="columnheader" class="col-span-1">Price</div>
						<div role="columnheader" class="col-span-1 md:text-left lg:text-center">Qty</div>
						<div role="columnheader" class="col-span-1 text-right">Subtotal</div>
					</div>
				</div>
				<div class="hidden md:block border-t border-grey-20 pb-6"></div>
				<div v-for="(item, index) in itemData" :key="index" role="row">
					<div class="flex py-8 md:py-6 border-b border-grey-20">
						<div class="w-full md:w-470 flex" role="cell">
							<span role="img" class="flex items-start justify-center mr-4">
								<MKProductImage size-class="w-75 md:w-104 h-75 md:h-104" :product-detail="item" />
							</span>
							<span>
								<p class="font-secondary-font-regular lg:font-primary-font-bold text-xl lg:text-base leading-6">
									{{ item['name'][apiLocale] }}
								</p>
								<MKFilterSubscription :show-tooltip="true" :item="item" />
								<div
									class="flex md:hidden flex-wrap items-center justify-start space-x-3 text-sm text-gray-500 font-primary-font-bold"
								></div>
							</span>
						</div>
						<div class="w-1/5 md:w-cart-card-md hidden md:flex flex-col">
							<div class="justify-end md:justify-between w-full grid grid-cols-3 md:text-sm lg:text-base">
								<div class="hidden md:block col-span-1" role="cell">
									<span class="font-primary-font-light md:text-sm lg:text-base"
										>{{ currencyDisplay
										}}{{ item['price']['value']['centAmount'] | centsToDollars | formatPrice }}</span
									>
								</div>
								<div class="hidden md:block col-span-1 md:text-left lg:text-center" role="cell">
									<span class="md:font-light text-left">{{ item.quantity }}</span>
								</div>
								<div class="hidden md:block col-span-1 text-right" role="cell">
									<span class="md:font-bold"
										>{{ currencyDisplay }}{{ item.priceDisplay.price | centsToDollars | formatPrice }}</span
									>
								</div>
							</div>
							<div class="flex h-16 md:h-9"></div>
						</div>
					</div>
					<MkClydeButton :is-checkout="false" :from-order="true" :item="item" />
				</div>
			</div>

			<div class="md:flex font-primary-font-bold md:text-sm lg:text-base md:leading-5 lg:leading-6">
				<div class="md:w-470"></div>
				<div class="md:w-cart-card-md">
					<MkOrderTotal checkout-class :from-success="true" :discount="false" class="mt-8 md:mt-6" />
					<MkOrder :from-success="true" />
				</div>
			</div>
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkSecondaryButton from '~/components/D2C/atoms/MkSecondaryButton.vue';
import MkOrderTotal from '~/components/D2C/molecules/MkOrderTotal.vue';
import MkOrder from '~/components/D2C/molecules/MkOrder.vue';
import MKFilterSubscription from '~/components/D2C/molecules/MkFilterSubscription/MkFilterSubscription.vue';
import MKProductImage from '~/components/D2C/organisms/MkProductImage/MkProductImage.vue';
import MkPageSpinner from '~/components/D2C/atoms/MkPageSpinner/MkPageSpinner.vue';
import MkClydeButton from '~/components/D2C/atoms/MkClydeButton.vue';
export default {
	name: 'MkOrdersDetail',
	components: {
		MkSecondaryButton,
		MkOrderTotal,
		MkOrder,
		MKFilterSubscription,
		MKProductImage,
		MkPageSpinner,
		MkClydeButton,
	},
	data() {
		return {
			loading: false,
		};
	},
	computed: {
		...mapState(['apiLocale', 'currencyDisplay', 'isEurope']),
		...mapState('USER_STORE', ['ORDER', 'ORDER_LOADED']),
		...mapState('CHECKOUT_STORE', ['FEATURE_CLYDE']),
		itemData: {
			get() {
				return this.ORDER ? this.ORDER.lineItems : [];
			},
			set(obj) {
				return obj;
			},
		},
		orderNumber() {
			return this.ORDER && this.ORDER.orderNumber;
		},
		orderDate() {
			return this.ORDER && this.ORDER.createdAt;
		},
	},
	async mounted() {
		const order = this.$route.query.orderId;
		if (order) {
			await this.$store.dispatch('USER_STORE/GET_ORDER', { orderId: order });
		}
		this.$root.$utility.elementFocus(this, 'print_btn');
	},
	methods: {
		getFormattedDate($date) {
			return this.$options.filters.ustToDate($date);
		},
		print() {
			const isChrome = Boolean(window.chrome);
			if (isChrome) {
				/*
				 * These 2 lines are here because as usual, for other browsers,
				 * the window is a tiny 100x100 box that the user will barely see.
				 * On Chrome, it needs to be big enough for the dialogue to be read
				 * (NB, it also includes a page preview).
				 */
				document.title = this.orderNumber;
				window.moveTo(0, 0);
				window.resizeTo(1440, 786);

				// This line causes the print dialogue to appear, as usual:
				window.print();

				/*
				 * This setTimeout isn't fired until after .print() has finished
				 * or the dialogue is closed/cancelled.
				 * It doesn't need to be a big pause, 500ms seems OK.
				 */
				setTimeout(function () {
					window.close();
				}, 500);
			} else {
				// For other browsers we can do things more briefly:
				window.print();
				window.close();
			}
		},
		async reorder() {
			this.loading = true;
			const $res = await this.$repositories.checkout.reOrder(this.ORDER.id);
			if ($res.status === 200 && $res.data) {
				const $cartId = $res.data.id;
				sessionStorage.setItem('cartId', $cartId);
				this.$store.commit('USER_STORE/SET_CART_ID', $cartId);
				await this.$store.dispatch('CART_STORE/FETCH_CART', $cartId);
				this.$router.push('/D2C/checkout/cart/');
			}
			this.loading = false;
		},
	},
};
</script>
<style>
@media print {
	#side-nav {
		visibility: hidden;
	}
}
</style>
